"""
Author: HECE - University of Liege, Pierre Archambeau, Christophe Dessers
Date: 2024

Copyright (c) 2024 University of Liege. All rights reserved.

This script and its content are protected by copyright law. Unauthorized
copying or distribution of this file, via any medium, is strictly prohibited.
"""

from . import constant as cst
from enum import Enum
# Constants representing the exchanges - Fortran

exchange_parameters_VHM_Umax            = 20 #Paramètre modèle VHM
exchange_parameters_VHM_Uevap           = 21 #Paramètre modèle VHM
exchange_parameters_VHM_au1             = 22 #Paramètre modèle VHM
exchange_parameters_VHM_au2             = 23 #Paramètre modèle VHM
exchange_parameters_VHM_au3             = 24 #Paramètre modèle VHM
exchange_parameters_VHM_aof1            = 25 #Paramètre modèle VHM
exchange_parameters_VHM_aof2            = 26 #Paramètre modèle VHM
exchange_parameters_VHM_aif1            = 27 #Paramètre modèle VHM
exchange_parameters_VHM_aif2            = 28 #Paramètre modèle VHM
exchange_parameters_VHM_kof             = 29 #Paramètre modèle VHM
exchange_parameters_VHM_kif             = 30 #Paramètre modèle VHM
exchange_parameters_VHM_kbf             = 31 #Paramètre modèle VHM
exchange_parameters_GR4_x1              = 32 #Paramètre modèle GR4
exchange_parameters_GR4_x2              = 33 #Paramètre modèle GR4
exchange_parameters_GR4_x3              = 34 #Paramètre modèle GR4
exchange_parameters_GR4_x4              = 35 #Paramètre modèle GR4
exchange_parameters_VHM_UH_kif          = 36 #Paramètre modèle VHM_UH
exchange_parameters_VHM_UH_kbf          = 37 #Paramètre modèle VHM_UH

exchange_parameters_HBV_FC              = 50 #Paramètre modèle HBV
exchange_parameters_HBV_beta            = 51 #Paramètre modèle HBV
exchange_parameters_HBV_PWP             = 52 #Paramètre modèle HBV
exchange_parameters_HBV_SUmax           = 53 #Paramètre modèle HBV
exchange_parameters_HBV_kr              = 54 #Paramètre modèle HBV
exchange_parameters_HBV_kif             = 55 #Paramètre modèle HBV
exchange_parameters_HBV_kperc           = 56 #Paramètre modèle HBV
exchange_parameters_HBV_kbf             = 57 #Paramètre modèle HBV
exchange_parameters_HBV_CFLUX           = 58 #Paramètre modèle HBV (HBV-96)
exchange_parameters_HBV_alpha           = 59 #Paramètre modèle HBV (HBV-96)

exchange_parameters_SAC_M_UZ_TW         = 60 #Paramètre modèle SAC-SMA (SACRAMENTO)
exchange_parameters_SAC_M_UZ_FW         = 61 #Paramètre modèle SAC-SMA (SACRAMENTO)
exchange_parameters_SAC_M_LZ_TW         = 62 #Paramètre modèle SAC-SMA (SACRAMENTO)
exchange_parameters_SAC_M_LZ_FP         = 63 #Paramètre modèle SAC-SMA (SACRAMENTO)
exchange_parameters_SAC_M_LZ_FS         = 64 #Paramètre modèle SAC-SMA (SACRAMENTO)
exchange_parameters_SAC_kif             = 65 #Paramètre modèle SAC-SMA (SACRAMENTO)
exchange_parameters_SAC_kbf_fp          = 66 #Paramètre modèle SAC-SMA (SACRAMENTO)
exchange_parameters_SAC_kbf_fs          = 67 #Paramètre modèle SAC-SMA (SACRAMENTO)
exchange_parameters_SAC_zperc           = 68 #Paramètre modèle SAC-SMA (SACRAMENTO)
exchange_parameters_SAC_rexp            = 69 #Paramètre modèle SAC-SMA (SACRAMENTO)
exchange_parameters_SAC_rserv           = 74 #Paramètre modèle SAC-SMA (SACRAMENTO)
exchange_parameters_SAC_pfree           = 75 #Paramètre modèle SAC-SMA (SACRAMENTO)
exchange_parameters_SAC_side            = 76 #Paramètre modèle SAC-SMA (SACRAMENTO)
exchange_parameters_SAC_riva            = 77 #Paramètre modèle SAC-SMA (SACRAMENTO)
exchange_parameters_SAC_adimp           = 78 #Paramètre modèle SAC-SMA (SACRAMENTO)
exchange_parameters_SAC_impv            = 79 #Paramètre modèle SAC-SMA (SACRAMENTO)

exchange_parameters_NAM_UMAX            = 82 #Paramètre modèle NAM
exchange_parameters_NAM_TOF             = 83 #Paramètre modèle NAM
exchange_parameters_NAM_TIF             = 84 #Paramètre modèle NAM
exchange_parameters_NAM_CQOF            = 85 #Paramètre modèle NAM
exchange_parameters_NAM_CKIF            = 86 #Paramètre modèle NAM
exchange_parameters_NAM_LMAX            = 87 #Paramètre modèle NAM
exchange_parameters_NAM_TG              = 88 #Paramètre modèle NAM
exchange_parameters_NAM_CK12            = 89 #Paramètre modèle NAM

exchange_parameters_NAM_CAREA           = 94 #Paramètre modèle NAM
exchange_parameters_NAM_CKBF            = 95 #Paramètre modèle NAM
exchange_parameters_NAM_GWLFL1          = 96 #Paramètre modèle NAM
exchange_parameters_NAM_GWLBF0          = 97 #Paramètre modèle NAM
exchange_parameters_NAM_SSIGMA          = 98 #Paramètre modèle NAM

exchange_parameters_Froude_min_riv      = 101 #Paramètre modèle VHM_UH méthode de Froude
exchange_parameters_Froude_max_riv      = 102 #Paramètre modèle VHM_UH méthode de Froude
exchange_parameters_Froude_min_bas      = 103 #Paramètre modèle VHM_UH méthode de Froude
exchange_parameters_Froude_max_bas      = 104 #Paramètre modèle VHM_UH méthode de Froude
exchange_parameters_Froude_discharge    = 105 #Paramètre modèle VHM_UH méthode de Froude
exchange_parameters_Nash_pt             = 106 #Paramètre modèle VHM_UH méthode de Nash (peak time)
exchange_parameters_Nash_nb             = 107 #Paramètre modèle VHM_UH méthode de Nash (nb reservoirs)
exchange_parameters_AsymTri_totTime     = 108 #Paramètre modèle VHM_UH méthode de HU triangulaire asymétrique (temps total)
exchange_parameters_AsymTri_pt          = 109 #Paramètre modèle VHM_UH méthode de HU triangulaire asymétrique (peak time)

exchange_parameters_Dist_RS_Hs          = 110 #Paramètre modèle distribué Réservoir de stockage
exchange_parameters_Dist_RS_TS          = 111 #Paramètre modèle distribué Réservoir de stockage
exchange_parameters_Dist_Soil_Umax      = 112 #Paramètre modèle distribué Soil
exchange_parameters_Dist_Soil_TSPAN     = 113 #Paramètre modèle distribué Soil
exchange_parameters_Dist_Horton_F0      = 114 #Paramètre modèle distribué Horton
exchange_parameters_Dist_Horton_FC      = 115 #Paramètre modèle distribué Horton
exchange_parameters_Dist_Horton_K       = 116 #Paramètre modèle distribué Horton
exchange_parameters_Dist_kif            = 117 #Paramètre modèle distribué pour réservoir linéaire couche épidermique (if)
exchange_parameters_Dist_qlif           = 118 #Paramètre modèle distribué pour réservoir linéaire couche épidermique (if)


# Constants representing the exchanges - Python
exchange_parameters_py_timeDelay        = -11

# All the keys of the param dictionary
class Type_Keys(Enum):
    """
    Enum to define the type of a parameter

    Strings are also used by Fortran Code -- modify with care
    """
    Name = 'Integer_or_Float'
    File = 'Integer'
    Group = 'Logical'
    Key = 'Float'
    Unit = 'File'
    Conv_factor = 'Convertion Factor'
    Range = 'Range'


# %% All model dictionnaries
VHM = {}
VHM["Nb"] = 12
VHM["Parameters"] = {}
VHM["Parameters"][exchange_parameters_VHM_aif1] = {}
VHM["Parameters"][exchange_parameters_VHM_aif1]["Name"] = "Coeff aif1"
VHM["Parameters"][exchange_parameters_VHM_aif1]["File"] = "simul_soil.param"
VHM["Parameters"][exchange_parameters_VHM_aif1]["Group"] = "Flow fraction parameters"
VHM["Parameters"][exchange_parameters_VHM_aif1]["Key"] = "Coeff aif1"
VHM["Parameters"][exchange_parameters_VHM_aif1]["Unit"] = "[-]"
VHM["Parameters"][exchange_parameters_VHM_aif2] = {}
VHM["Parameters"][exchange_parameters_VHM_aif2]["Name"] = "Coeff aif2"
VHM["Parameters"][exchange_parameters_VHM_aif2]["File"] = "simul_soil.param"
VHM["Parameters"][exchange_parameters_VHM_aif2]["Group"] = "Flow fraction parameters"
VHM["Parameters"][exchange_parameters_VHM_aif2]["Key"] = "Coeff aif2"
VHM["Parameters"][exchange_parameters_VHM_aif2]["Unit"] = "[-]"
VHM["Parameters"][exchange_parameters_VHM_aof1] = {}
VHM["Parameters"][exchange_parameters_VHM_aof1]["Name"] = "Coeff aof1"
VHM["Parameters"][exchange_parameters_VHM_aof1]["File"] = "simul_soil.param"
VHM["Parameters"][exchange_parameters_VHM_aof1]["Group"] = "Flow fraction parameters"
VHM["Parameters"][exchange_parameters_VHM_aof1]["Key"] = "Coeff aof1"
VHM["Parameters"][exchange_parameters_VHM_aof1]["Unit"] = "[-]"
VHM["Parameters"][exchange_parameters_VHM_aof2] = {}
VHM["Parameters"][exchange_parameters_VHM_aof2]["Name"] = "Coeff aof2"
VHM["Parameters"][exchange_parameters_VHM_aof2]["File"] = "simul_soil.param"
VHM["Parameters"][exchange_parameters_VHM_aof2]["Group"] = "Flow fraction parameters"
VHM["Parameters"][exchange_parameters_VHM_aof2]["Key"] = "Coeff aof2"
VHM["Parameters"][exchange_parameters_VHM_aof2]["Unit"] = "[-]"
VHM["Parameters"][exchange_parameters_VHM_au1] = {}
VHM["Parameters"][exchange_parameters_VHM_au1]["Name"] = "Coeff au1"
VHM["Parameters"][exchange_parameters_VHM_au1]["File"] = "simul_soil.param" 
VHM["Parameters"][exchange_parameters_VHM_au1]["Group"] = "Flow fraction parameters"
VHM["Parameters"][exchange_parameters_VHM_au1]["Key"] = "Coeff au1"
VHM["Parameters"][exchange_parameters_VHM_au1]["Unit"] = "[-]"
VHM["Parameters"][exchange_parameters_VHM_au2] = {}
VHM["Parameters"][exchange_parameters_VHM_au2]["Name"] = "Coeff au2"
VHM["Parameters"][exchange_parameters_VHM_au2]["File"] = "simul_soil.param"
VHM["Parameters"][exchange_parameters_VHM_au2]["Group"] = "Flow fraction parameters"
VHM["Parameters"][exchange_parameters_VHM_au2]["Key"] = "Coeff au2"
VHM["Parameters"][exchange_parameters_VHM_au2]["Unit"] = "[-]"
VHM["Parameters"][exchange_parameters_VHM_au3] = {}
VHM["Parameters"][exchange_parameters_VHM_au3]["Name"] = "Coeff au3"
VHM["Parameters"][exchange_parameters_VHM_au3]["File"] = "simul_soil.param"
VHM["Parameters"][exchange_parameters_VHM_au3]["Group"] = "Flow fraction parameters"
VHM["Parameters"][exchange_parameters_VHM_au3]["Key"] = "Coeff au3"
VHM["Parameters"][exchange_parameters_VHM_au3]["Unit"] = "[-]"
VHM["Parameters"][exchange_parameters_VHM_Umax] = {}
VHM["Parameters"][exchange_parameters_VHM_Umax]["Name"] = "Umax"
VHM["Parameters"][exchange_parameters_VHM_Umax]["File"] = "simul_soil.param"
VHM["Parameters"][exchange_parameters_VHM_Umax]["Group"] = "Soil characteristics"
VHM["Parameters"][exchange_parameters_VHM_Umax]["Key"] = "Umax"
VHM["Parameters"][exchange_parameters_VHM_Umax]["Unit"] = "[mm]"
VHM["Parameters"][exchange_parameters_VHM_Uevap] = {}
VHM["Parameters"][exchange_parameters_VHM_Uevap]["Name"] = "Uevap"
VHM["Parameters"][exchange_parameters_VHM_Uevap]["File"] = "simul_soil.param"
VHM["Parameters"][exchange_parameters_VHM_Uevap]["Group"] = "Soil characteristics"
VHM["Parameters"][exchange_parameters_VHM_Uevap]["Key"] = "Uevap"
VHM["Parameters"][exchange_parameters_VHM_Uevap]["Unit"] = "[mm]"
VHM["Parameters"][exchange_parameters_VHM_kof] = {}
VHM["Parameters"][exchange_parameters_VHM_kof]["Name"] = "kof"
VHM["Parameters"][exchange_parameters_VHM_kof]["File"] = "simul_of.param"
VHM["Parameters"][exchange_parameters_VHM_kof]["Group"] = "Time Parameters"
VHM["Parameters"][exchange_parameters_VHM_kof]["Key"] = "Lagtime"
VHM["Parameters"][exchange_parameters_VHM_kof]["Unit"] = "[sec]"
VHM["Parameters"][exchange_parameters_VHM_kof]["Convertion Factor"] = 1/3600.0    # [sec] -> [h]
VHM["Parameters"][exchange_parameters_VHM_kif] = {}
VHM["Parameters"][exchange_parameters_VHM_kif]["Name"] = "kif"
VHM["Parameters"][exchange_parameters_VHM_kif]["File"] = "simul_if.param"
VHM["Parameters"][exchange_parameters_VHM_kif]["Group"] = "Time Parameters"
VHM["Parameters"][exchange_parameters_VHM_kif]["Key"] = "Lagtime"
VHM["Parameters"][exchange_parameters_VHM_kif]["Unit"] = "[sec]"
VHM["Parameters"][exchange_parameters_VHM_kif]["Convertion Factor"] = 1/3600.0    # [sec] -> [h]
VHM["Parameters"][exchange_parameters_VHM_kbf] = {}
VHM["Parameters"][exchange_parameters_VHM_kbf]["Name"] = "kbf"
VHM["Parameters"][exchange_parameters_VHM_kbf]["File"] = "simul_bf.param"
VHM["Parameters"][exchange_parameters_VHM_kbf]["Group"] = "Time Parameters"
VHM["Parameters"][exchange_parameters_VHM_kbf]["Key"] = "Lagtime"
VHM["Parameters"][exchange_parameters_VHM_kbf]["Unit"] = "[sec]"
VHM["Parameters"][exchange_parameters_VHM_kbf]["Convertion Factor"] = 1/3600.0    # [sec] -> [h]
GR4 = {}
GR4["Parameters"] = {}
GR4["Nb"] = 4
GR4["Parameters"][exchange_parameters_GR4_x1] = {}
GR4["Parameters"][exchange_parameters_GR4_x1]["Name"] = "X1"
GR4["Parameters"][exchange_parameters_GR4_x1]["File"] = "simul_GR4.param"
GR4["Parameters"][exchange_parameters_GR4_x1]["Group"] = "GR4 Parameters"
GR4["Parameters"][exchange_parameters_GR4_x1]["Key"] = "X1"
GR4["Parameters"][exchange_parameters_GR4_x1]["Unit"] = "[mm]"
GR4["Parameters"][exchange_parameters_GR4_x2] = {}
GR4["Parameters"][exchange_parameters_GR4_x2]["Name"] = "X2"
GR4["Parameters"][exchange_parameters_GR4_x2]["File"] = "simul_GR4.param"
GR4["Parameters"][exchange_parameters_GR4_x2]["Group"] = "GR4 Parameters"
GR4["Parameters"][exchange_parameters_GR4_x2]["Key"] = "X2"
GR4["Parameters"][exchange_parameters_GR4_x2]["Unit"] = "[mm]"
GR4["Parameters"][exchange_parameters_GR4_x3] = {}
GR4["Parameters"][exchange_parameters_GR4_x3]["Name"] = "X3"
GR4["Parameters"][exchange_parameters_GR4_x3]["File"] = "simul_GR4.param"
GR4["Parameters"][exchange_parameters_GR4_x3]["Group"] = "GR4 Parameters"
GR4["Parameters"][exchange_parameters_GR4_x3]["Key"] = "X3"
GR4["Parameters"][exchange_parameters_GR4_x3]["Unit"] = "[mm]"
GR4["Parameters"][exchange_parameters_GR4_x4] = {}
GR4["Parameters"][exchange_parameters_GR4_x4]["Name"] = "X4"
GR4["Parameters"][exchange_parameters_GR4_x4]["File"] = "simul_GR4.param"
GR4["Parameters"][exchange_parameters_GR4_x4]["Group"] = "GR4 Parameters"
GR4["Parameters"][exchange_parameters_GR4_x4]["Key"] = "X4"
GR4["Parameters"][exchange_parameters_GR4_x4]["Unit"] = "[hours]"
VHM_UH = {}
UH = {}
# distributed model with 2 layers : 1 dist UH & 1 lumped linear reservoir
UHDIST_LINBF = {}
UHDIST_LINBF["Nb"] = 13
UHDIST_LINBF["Parameters"] = {}
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Soil_Umax] = {}
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Soil_Umax]["Name"] = "Umax"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Soil_Umax]["File"] = "simul_soil.param"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Soil_Umax]["Group"] = "Distributed production model parameters"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Soil_Umax]["Key"] = "Umax"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Soil_Umax]["Unit"] = "[mm]"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Soil_TSPAN] = {}
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Soil_TSPAN]["Name"] = "Time span soil"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Soil_TSPAN]["File"] = "simul_soil.param"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Soil_TSPAN]["Group"] = "Distributed production model parameters"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Soil_TSPAN]["Key"] = "Time span soil"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Soil_TSPAN]["Unit"] = "[sec]"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Soil_TSPAN]["Convertion Factor"] = 1/3600.0    # [sec] -> [h]
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Horton_F0] = {}
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Horton_F0]["Name"] = "Horton F0"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Horton_F0]["File"] = "simul_soil.param"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Horton_F0]["Group"] = "Horton parameters"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Horton_F0]["Key"] = "F0"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Horton_FC] = {}
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Horton_FC]["Name"] = "Horton Fc"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Horton_FC]["File"] = "simul_soil.param"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Horton_FC]["Group"] = "Horton parameters"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Horton_FC]["Key"] = "Fc"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Horton_K] = {}
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Horton_K]["Name"] = "Horton k"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Horton_K]["File"] = "simul_soil.param"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Horton_K]["Group"] = "Horton parameters"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_Horton_K]["Key"] = "k"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_RS_Hs] = {}
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_RS_Hs]["Name"] = "Storage reservoir Hs"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_RS_Hs]["File"] = "simul_soil.param"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_RS_Hs]["Group"] = "Storage reservoir parameters"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_RS_Hs]["Key"] = "hs"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_RS_Hs]["Unit"] = "[mm]"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_RS_TS] = {}
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_RS_TS]["Name"] = "Storage reservoir Ts"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_RS_TS]["File"] = "simul_soil.param"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_RS_TS]["Group"] = "Storage reservoir parameters"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_RS_TS]["Key"] = "Ts"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_RS_TS]["Unit"] = "[h]"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_kif] = {}
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_kif]["Name"] = "kif"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_kif]["File"] = "simul_if.param"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_kif]["Group"] = "Time Parameters"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_kif]["Key"] = "Lagtime"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_kif]["Unit"] = "[sec]"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_kif]["Convertion Factor"] = 1/3600.0    # [sec] -> [h]
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_qlif] = {}
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_qlif]["Name"] = "Qlif"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_qlif]["File"] = "simul_if.param"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_qlif]["Group"] = "Time Parameters"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_qlif]["Key"] = "Specific flow rate"
UHDIST_LINBF["Parameters"][exchange_parameters_Dist_qlif]["Unit"] = "[m^2/s]"
UHDIST_LINBF["Parameters"][exchange_parameters_Froude_min_riv] = {}
UHDIST_LINBF["Parameters"][exchange_parameters_Froude_min_riv]["Name"] = "Froude min (river)"
UHDIST_LINBF["Parameters"][exchange_parameters_Froude_min_riv]["File"] = "..\\Characteristic_maps\\Drainage_basin.param"
UHDIST_LINBF["Parameters"][exchange_parameters_Froude_min_riv]["Group"] = "Froude parameters"
UHDIST_LINBF["Parameters"][exchange_parameters_Froude_min_riv]["Key"] = "Froude min (river)"
UHDIST_LINBF["Parameters"][exchange_parameters_Froude_max_riv] = {}
UHDIST_LINBF["Parameters"][exchange_parameters_Froude_max_riv]["Name"] = "Froude max (river)"
UHDIST_LINBF["Parameters"][exchange_parameters_Froude_max_riv]["File"] = "..\\Characteristic_maps\\Drainage_basin.param"
UHDIST_LINBF["Parameters"][exchange_parameters_Froude_max_riv]["Group"] = "Froude parameters"
UHDIST_LINBF["Parameters"][exchange_parameters_Froude_max_riv]["Key"] = "Froude max (river)"
UHDIST_LINBF["Parameters"][exchange_parameters_Froude_min_bas] = {}
UHDIST_LINBF["Parameters"][exchange_parameters_Froude_min_bas]["Name"] = "Froude min (basin)"
UHDIST_LINBF["Parameters"][exchange_parameters_Froude_min_bas]["File"] = "..\\Characteristic_maps\\Drainage_basin.param"
UHDIST_LINBF["Parameters"][exchange_parameters_Froude_min_bas]["Group"] = "Froude parameters"
UHDIST_LINBF["Parameters"][exchange_parameters_Froude_min_bas]["Key"] = "Froude min (basin)"
UHDIST_LINBF["Parameters"][exchange_parameters_Froude_max_bas] = {}
UHDIST_LINBF["Parameters"][exchange_parameters_Froude_max_bas]["Name"] = "Froude max (basin)"
UHDIST_LINBF["Parameters"][exchange_parameters_Froude_max_bas]["File"] = "..\\Characteristic_maps\\Drainage_basin.param"
UHDIST_LINBF["Parameters"][exchange_parameters_Froude_max_bas]["Group"] = "Froude parameters"
UHDIST_LINBF["Parameters"][exchange_parameters_Froude_max_bas]["Key"] = "Froude max (basin)"
UHDIST_LINBF["Parameters"][exchange_parameters_Froude_discharge] = {}
UHDIST_LINBF["Parameters"][exchange_parameters_Froude_discharge]["Name"] = "Froude discharge"
UHDIST_LINBF["Parameters"][exchange_parameters_Froude_discharge]["File"] = "..\\Characteristic_maps\\Drainage_basin.param"
UHDIST_LINBF["Parameters"][exchange_parameters_Froude_discharge]["Group"] = "Froude parameters"
UHDIST_LINBF["Parameters"][exchange_parameters_Froude_discharge]["Key"] = "Discharge"
UHDIST_LINBF["Parameters"][exchange_parameters_Froude_discharge]["Unit"] = "[m^3/s]"

HBV = {}
HBV["Nb"] = 10
HBV["Parameters"] = {}
HBV["Parameters"][exchange_parameters_HBV_FC] = {}
HBV["Parameters"][exchange_parameters_HBV_FC]["Name"] = "Fc"
HBV["Parameters"][exchange_parameters_HBV_FC]["File"] = "simul_soil.param"
HBV["Parameters"][exchange_parameters_HBV_FC]["Group"] = "Parameters"
HBV["Parameters"][exchange_parameters_HBV_FC]["Key"] = "Fc"
HBV["Parameters"][exchange_parameters_HBV_FC]["Unit"] = "[mm]"
HBV["Parameters"][exchange_parameters_HBV_FC]["Range"] = (50.0, 650.0)
HBV["Parameters"][exchange_parameters_HBV_beta] = {}
HBV["Parameters"][exchange_parameters_HBV_beta]["Name"] = "Beta"
HBV["Parameters"][exchange_parameters_HBV_beta]["File"] = "simul_soil.param"
HBV["Parameters"][exchange_parameters_HBV_beta]["Group"] = "Parameters"
HBV["Parameters"][exchange_parameters_HBV_beta]["Key"] = "Beta"
HBV["Parameters"][exchange_parameters_HBV_beta]["Unit"] = "[-]"
HBV["Parameters"][exchange_parameters_HBV_beta]["Range"] = (1.0, 5.0)
HBV["Parameters"][exchange_parameters_HBV_PWP] = {}
HBV["Parameters"][exchange_parameters_HBV_PWP]["Name"] = "PWP"
HBV["Parameters"][exchange_parameters_HBV_PWP]["File"] = "simul_soil.param"
HBV["Parameters"][exchange_parameters_HBV_PWP]["Group"] = "Parameters"
HBV["Parameters"][exchange_parameters_HBV_PWP]["Key"] = "PWP"
HBV["Parameters"][exchange_parameters_HBV_PWP]["Unit"] = "[-]"
HBV["Parameters"][exchange_parameters_HBV_PWP]["Range"] = (0.03, 1.0)
HBV["Parameters"][exchange_parameters_HBV_SUmax] = {}
HBV["Parameters"][exchange_parameters_HBV_SUmax]["Name"] = "Su_max"
HBV["Parameters"][exchange_parameters_HBV_SUmax]["File"] = "simul_UZ.param"
HBV["Parameters"][exchange_parameters_HBV_SUmax]["Group"] = "Parameters"
HBV["Parameters"][exchange_parameters_HBV_SUmax]["Key"] = "Su max"
HBV["Parameters"][exchange_parameters_HBV_SUmax]["Unit"] = "[mm]"
HBV["Parameters"][exchange_parameters_HBV_SUmax]["Range"] = (0.0, 100.0)
HBV["Parameters"][exchange_parameters_HBV_kr] = {}
HBV["Parameters"][exchange_parameters_HBV_kr]["Name"] = "K_r"
HBV["Parameters"][exchange_parameters_HBV_kr]["File"] = "simul_UZ.param"
HBV["Parameters"][exchange_parameters_HBV_kr]["Group"] = "Parameters"
HBV["Parameters"][exchange_parameters_HBV_kr]["Key"] = "Kr"
HBV["Parameters"][exchange_parameters_HBV_kr]["Unit"] = "[1/h]"
HBV["Parameters"][exchange_parameters_HBV_kr]["Range"] = (0.05/24.0, 0.5/24.0)
HBV["Parameters"][exchange_parameters_HBV_kif] = {}
HBV["Parameters"][exchange_parameters_HBV_kif]["Name"] = "K_if"
HBV["Parameters"][exchange_parameters_HBV_kif]["File"] = "simul_UZ.param"
HBV["Parameters"][exchange_parameters_HBV_kif]["Group"] = "Parameters"
HBV["Parameters"][exchange_parameters_HBV_kif]["Key"] = "Kif"
HBV["Parameters"][exchange_parameters_HBV_kif]["Unit"] = "[1/h]"
HBV["Parameters"][exchange_parameters_HBV_kif]["Range"] = (0.01/24.0, 0.4/24.0)
HBV["Parameters"][exchange_parameters_HBV_kperc] = {}
HBV["Parameters"][exchange_parameters_HBV_kperc]["Name"] = "K_perc"
HBV["Parameters"][exchange_parameters_HBV_kperc]["File"] = "simul_UZ.param"
HBV["Parameters"][exchange_parameters_HBV_kperc]["Group"] = "Parameters"
HBV["Parameters"][exchange_parameters_HBV_kperc]["Key"] = "Kperc"
HBV["Parameters"][exchange_parameters_HBV_kperc]["Unit"] = "[1/h]"
HBV["Parameters"][exchange_parameters_HBV_kperc]["Range"] = (0.0, 0.8/24.0)
HBV["Parameters"][exchange_parameters_HBV_kbf] = {}
HBV["Parameters"][exchange_parameters_HBV_kbf]["Name"] = "K_bf"
HBV["Parameters"][exchange_parameters_HBV_kbf]["File"] = "simul_bf.param"
HBV["Parameters"][exchange_parameters_HBV_kbf]["Group"] = "Parameters"
HBV["Parameters"][exchange_parameters_HBV_kbf]["Key"] = "Lagtime"
HBV["Parameters"][exchange_parameters_HBV_kbf]["Unit"] = "[sec]"
HBV["Parameters"][exchange_parameters_HBV_kbf]["Convertion Factor"] = 1/3600.0    # [sec] -> [h]
HBV["Parameters"][exchange_parameters_HBV_kbf]["Range"] = (0.0, 0.15/24.0)
HBV["Parameters"][exchange_parameters_HBV_CFLUX] = {}
HBV["Parameters"][exchange_parameters_HBV_CFLUX]["Name"] = "CFLUX"
HBV["Parameters"][exchange_parameters_HBV_CFLUX]["File"] = "simul_soil.param"
HBV["Parameters"][exchange_parameters_HBV_CFLUX]["Group"] = "Parameters"
HBV["Parameters"][exchange_parameters_HBV_CFLUX]["Key"] = "CFLUX"
HBV["Parameters"][exchange_parameters_HBV_CFLUX]["Unit"] = "[mm/h]"
HBV["Parameters"][exchange_parameters_HBV_alpha] = {}
HBV["Parameters"][exchange_parameters_HBV_alpha]["Name"] = "Alpha"
HBV["Parameters"][exchange_parameters_HBV_alpha]["File"] = "simul_UZ.param"
HBV["Parameters"][exchange_parameters_HBV_alpha]["Group"] = "Parameters"
HBV["Parameters"][exchange_parameters_HBV_alpha]["Key"] = "Alpha"
HBV["Parameters"][exchange_parameters_HBV_alpha]["Unit"] = "[-]"


SAC_SMA = {}
SAC_SMA["Nb"] = 16
SAC_SMA["Parameters"] = {}
SAC_SMA["Parameters"][exchange_parameters_SAC_M_UZ_TW] = {}
SAC_SMA["Parameters"][exchange_parameters_SAC_M_UZ_TW]["Name"] = "UZ_TW Max"
SAC_SMA["Parameters"][exchange_parameters_SAC_M_UZ_TW]["File"] = "simul_UZ.param"
SAC_SMA["Parameters"][exchange_parameters_SAC_M_UZ_TW]["Group"] = "Parameters"
SAC_SMA["Parameters"][exchange_parameters_SAC_M_UZ_TW]["Key"] = "M_UZ_TW"
SAC_SMA["Parameters"][exchange_parameters_SAC_M_UZ_TW]["Unit"] = "[mm]"
SAC_SMA["Parameters"][exchange_parameters_SAC_M_UZ_TW]["Range"] = (10.0, 150.0)
SAC_SMA["Parameters"][exchange_parameters_SAC_M_UZ_FW] = {}
SAC_SMA["Parameters"][exchange_parameters_SAC_M_UZ_FW]["Name"] = "UZ_FW Max"
SAC_SMA["Parameters"][exchange_parameters_SAC_M_UZ_FW]["File"] = "simul_UZ.param"
SAC_SMA["Parameters"][exchange_parameters_SAC_M_UZ_FW]["Group"] = "Parameters"
SAC_SMA["Parameters"][exchange_parameters_SAC_M_UZ_FW]["Key"] = "M_UZ_FW"
SAC_SMA["Parameters"][exchange_parameters_SAC_M_UZ_FW]["Unit"] = "[mm]"
SAC_SMA["Parameters"][exchange_parameters_SAC_M_UZ_FW]["Range"] = (5.0, 100.0)
SAC_SMA["Parameters"][exchange_parameters_SAC_M_LZ_TW] = {}
SAC_SMA["Parameters"][exchange_parameters_SAC_M_LZ_TW]["Name"] = "LZ_TW Max"
SAC_SMA["Parameters"][exchange_parameters_SAC_M_LZ_TW]["File"] = "simul_LZ.param"
SAC_SMA["Parameters"][exchange_parameters_SAC_M_LZ_TW]["Group"] = "Parameters"
SAC_SMA["Parameters"][exchange_parameters_SAC_M_LZ_TW]["Key"] = "M_LZ_TW"
SAC_SMA["Parameters"][exchange_parameters_SAC_M_LZ_TW]["Unit"] = "[mm]"
SAC_SMA["Parameters"][exchange_parameters_SAC_M_LZ_TW]["Range"] = (50.0,400.0)
SAC_SMA["Parameters"][exchange_parameters_SAC_M_LZ_FP] = {}
SAC_SMA["Parameters"][exchange_parameters_SAC_M_LZ_FP]["Name"] = "LZ_FP Max"
SAC_SMA["Parameters"][exchange_parameters_SAC_M_LZ_FP]["File"] = "simul_LZ.param"
SAC_SMA["Parameters"][exchange_parameters_SAC_M_LZ_FP]["Group"] = "Parameters"
SAC_SMA["Parameters"][exchange_parameters_SAC_M_LZ_FP]["Key"] = "M_LZ_FP"
SAC_SMA["Parameters"][exchange_parameters_SAC_M_LZ_FP]["Unit"] = "[mm]"
SAC_SMA["Parameters"][exchange_parameters_SAC_M_LZ_FP]["Range"] = (30.0, 800.0)
SAC_SMA["Parameters"][exchange_parameters_SAC_M_LZ_FS] = {}
SAC_SMA["Parameters"][exchange_parameters_SAC_M_LZ_FS]["Name"] = "LZ_FS Max"
SAC_SMA["Parameters"][exchange_parameters_SAC_M_LZ_FS]["File"] = "simul_LZ.param"
SAC_SMA["Parameters"][exchange_parameters_SAC_M_LZ_FS]["Group"] = "Parameters"
SAC_SMA["Parameters"][exchange_parameters_SAC_M_LZ_FS]["Key"] = "M_LZ_FS"
SAC_SMA["Parameters"][exchange_parameters_SAC_M_LZ_FS]["Unit"] = "[mm]"
SAC_SMA["Parameters"][exchange_parameters_SAC_M_LZ_FS]["Range"] = (30.0, 800.0)
SAC_SMA["Parameters"][exchange_parameters_SAC_kif] = {}
SAC_SMA["Parameters"][exchange_parameters_SAC_kif]["Name"] = "Kif"
SAC_SMA["Parameters"][exchange_parameters_SAC_kif]["File"] = "simul_UZ.param"
SAC_SMA["Parameters"][exchange_parameters_SAC_kif]["Group"] = "Parameters"
SAC_SMA["Parameters"][exchange_parameters_SAC_kif]["Key"] = "K_if"
SAC_SMA["Parameters"][exchange_parameters_SAC_kif]["Unit"] = "[1/h]"
SAC_SMA["Parameters"][exchange_parameters_SAC_kif]["Range"] = (0.1/24, 0.75/24)
SAC_SMA["Parameters"][exchange_parameters_SAC_kbf_fp] = {}
SAC_SMA["Parameters"][exchange_parameters_SAC_kbf_fp]["Name"] = "Kbf_fp"
SAC_SMA["Parameters"][exchange_parameters_SAC_kbf_fp]["File"] = "simul_LZ.param"
SAC_SMA["Parameters"][exchange_parameters_SAC_kbf_fp]["Group"] = "Parameters"
SAC_SMA["Parameters"][exchange_parameters_SAC_kbf_fp]["Key"] = "K_fp"
SAC_SMA["Parameters"][exchange_parameters_SAC_kbf_fp]["Unit"] = "[1/h]"
SAC_SMA["Parameters"][exchange_parameters_SAC_kbf_fp]["Range"] = (0.001/24, 0.03/24)
SAC_SMA["Parameters"][exchange_parameters_SAC_kbf_fs] = {}
SAC_SMA["Parameters"][exchange_parameters_SAC_kbf_fs]["Name"] = "Kbf_fs"
SAC_SMA["Parameters"][exchange_parameters_SAC_kbf_fs]["File"] = "simul_LZ.param"
SAC_SMA["Parameters"][exchange_parameters_SAC_kbf_fs]["Group"] = "Parameters"
SAC_SMA["Parameters"][exchange_parameters_SAC_kbf_fs]["Key"] = "K_fs"
SAC_SMA["Parameters"][exchange_parameters_SAC_kbf_fs]["Unit"] = "[1/h]"
SAC_SMA["Parameters"][exchange_parameters_SAC_kbf_fs]["Range"] = (0.02/24, 0.3/24)
SAC_SMA["Parameters"][exchange_parameters_SAC_zperc] = {}
SAC_SMA["Parameters"][exchange_parameters_SAC_zperc]["Name"] = "Z_perc"
SAC_SMA["Parameters"][exchange_parameters_SAC_zperc]["File"] = "simul_UZ.param"
SAC_SMA["Parameters"][exchange_parameters_SAC_zperc]["Group"] = "Parameters"
SAC_SMA["Parameters"][exchange_parameters_SAC_zperc]["Key"] = "Z_perc"
SAC_SMA["Parameters"][exchange_parameters_SAC_zperc]["Unit"] = "[-]"
SAC_SMA["Parameters"][exchange_parameters_SAC_zperc]["Range"] = (10.0, 350.0)
SAC_SMA["Parameters"][exchange_parameters_SAC_rexp] = {}
SAC_SMA["Parameters"][exchange_parameters_SAC_rexp]["Name"] = "R_exp"
SAC_SMA["Parameters"][exchange_parameters_SAC_rexp]["File"] = "simul_UZ.param"
SAC_SMA["Parameters"][exchange_parameters_SAC_rexp]["Group"] = "Parameters"
SAC_SMA["Parameters"][exchange_parameters_SAC_rexp]["Key"] = "R_exp"
SAC_SMA["Parameters"][exchange_parameters_SAC_rexp]["Unit"] = "[-]"
SAC_SMA["Parameters"][exchange_parameters_SAC_rexp]["Range"] = (1.0, 4.0)
SAC_SMA["Parameters"][exchange_parameters_SAC_rserv] = {}
SAC_SMA["Parameters"][exchange_parameters_SAC_rserv]["Name"] = "R_serv"
SAC_SMA["Parameters"][exchange_parameters_SAC_rserv]["File"] = "simul_LZ.param"
SAC_SMA["Parameters"][exchange_parameters_SAC_rserv]["Group"] = "Parameters"
SAC_SMA["Parameters"][exchange_parameters_SAC_rserv]["Key"] = "R_serv"
SAC_SMA["Parameters"][exchange_parameters_SAC_rserv]["Unit"] = "[-]"
SAC_SMA["Parameters"][exchange_parameters_SAC_rserv]["Range"] = (0.0, 1.0)
SAC_SMA["Parameters"][exchange_parameters_SAC_pfree] = {}
SAC_SMA["Parameters"][exchange_parameters_SAC_pfree]["Name"] = "P_free"
SAC_SMA["Parameters"][exchange_parameters_SAC_pfree]["File"] = "simul_LZ.param"
SAC_SMA["Parameters"][exchange_parameters_SAC_pfree]["Group"] = "Parameters"
SAC_SMA["Parameters"][exchange_parameters_SAC_pfree]["Key"] = "Pfree"
SAC_SMA["Parameters"][exchange_parameters_SAC_pfree]["Unit"] = "[-]"
SAC_SMA["Parameters"][exchange_parameters_SAC_pfree]["Range"] = (0.0, 0.6)
SAC_SMA["Parameters"][exchange_parameters_SAC_side] = {}
SAC_SMA["Parameters"][exchange_parameters_SAC_side]["Name"] = "Side"
SAC_SMA["Parameters"][exchange_parameters_SAC_side]["File"] = "simul_out.param"
SAC_SMA["Parameters"][exchange_parameters_SAC_side]["Group"] = "Parameters"
SAC_SMA["Parameters"][exchange_parameters_SAC_side]["Key"] = "Side"
SAC_SMA["Parameters"][exchange_parameters_SAC_side]["Unit"] = "[-]"
SAC_SMA["Parameters"][exchange_parameters_SAC_side]["Range"] = (0.0, 0.5)
SAC_SMA["Parameters"][exchange_parameters_SAC_riva] = {}
SAC_SMA["Parameters"][exchange_parameters_SAC_riva]["Name"] = "Riva"
SAC_SMA["Parameters"][exchange_parameters_SAC_riva]["File"] = "simul_out.param"
SAC_SMA["Parameters"][exchange_parameters_SAC_riva]["Group"] = "Parameters"
SAC_SMA["Parameters"][exchange_parameters_SAC_riva]["Key"] = "Riva"
SAC_SMA["Parameters"][exchange_parameters_SAC_riva]["Unit"] = "[-]"
SAC_SMA["Parameters"][exchange_parameters_SAC_riva]["Range"] = (0.0, 0.2)
SAC_SMA["Parameters"][exchange_parameters_SAC_adimp] = {}
SAC_SMA["Parameters"][exchange_parameters_SAC_adimp]["Name"] = "S Adimp"
SAC_SMA["Parameters"][exchange_parameters_SAC_adimp]["File"] = "simul_UZ.param"
SAC_SMA["Parameters"][exchange_parameters_SAC_adimp]["Group"] = "Parameters"
SAC_SMA["Parameters"][exchange_parameters_SAC_adimp]["Key"] = "S_adimp"
SAC_SMA["Parameters"][exchange_parameters_SAC_adimp]["Unit"] = "[-]"
SAC_SMA["Parameters"][exchange_parameters_SAC_adimp]["Range"] = (0.0, 0.2)
SAC_SMA["Parameters"][exchange_parameters_SAC_impv] = {}
SAC_SMA["Parameters"][exchange_parameters_SAC_impv]["Name"] = "S Imperv"
SAC_SMA["Parameters"][exchange_parameters_SAC_impv]["File"] = "simul_UZ.param"
SAC_SMA["Parameters"][exchange_parameters_SAC_impv]["Group"] = "Parameters"
SAC_SMA["Parameters"][exchange_parameters_SAC_impv]["Key"] = "S_imperv"
SAC_SMA["Parameters"][exchange_parameters_SAC_impv]["Unit"] = "[-]"
SAC_SMA["Parameters"][exchange_parameters_SAC_impv]["Range"] = (0.0, 0.05)


NAM = {}
NAM["Nb"] = 10
NAM["Parameters"] = {}
NAM["Parameters"][exchange_parameters_NAM_UMAX] = {}
NAM["Parameters"][exchange_parameters_NAM_UMAX]["Name"] = "U_max"
NAM["Parameters"][exchange_parameters_NAM_UMAX]["File"] = "simul_SS.param"
NAM["Parameters"][exchange_parameters_NAM_UMAX]["Group"] = "Parameters"
NAM["Parameters"][exchange_parameters_NAM_UMAX]["Key"] = "Umax"
NAM["Parameters"][exchange_parameters_NAM_UMAX]["Unit"] = "[mm]"
NAM["Parameters"][exchange_parameters_NAM_UMAX]["Range"] = (10.0, 20.0)
NAM["Parameters"][exchange_parameters_NAM_TOF] = {}
NAM["Parameters"][exchange_parameters_NAM_TOF]["Name"] = "TOF"
NAM["Parameters"][exchange_parameters_NAM_TOF]["File"] = "simul_SS.param"
NAM["Parameters"][exchange_parameters_NAM_TOF]["Group"] = "Parameters"
NAM["Parameters"][exchange_parameters_NAM_TOF]["Key"] = "TOF"
NAM["Parameters"][exchange_parameters_NAM_TOF]["Unit"] = "[-]"
NAM["Parameters"][exchange_parameters_NAM_TOF]["Range"] = (0.0, 0.99)
NAM["Parameters"][exchange_parameters_NAM_TIF] = {}
NAM["Parameters"][exchange_parameters_NAM_TIF]["Name"] = "TIF"
NAM["Parameters"][exchange_parameters_NAM_TIF]["File"] = "simul_SS.param"
NAM["Parameters"][exchange_parameters_NAM_TIF]["Group"] = "Parameters"
NAM["Parameters"][exchange_parameters_NAM_TIF]["Key"] = "TIF"
NAM["Parameters"][exchange_parameters_NAM_TIF]["Unit"] = "[-]"
NAM["Parameters"][exchange_parameters_NAM_TIF]["Range"] = (0.0, 0.99)
NAM["Parameters"][exchange_parameters_NAM_CQOF] = {}
NAM["Parameters"][exchange_parameters_NAM_CQOF]["Name"] = "C_qof"
NAM["Parameters"][exchange_parameters_NAM_CQOF]["File"] = "simul_SS.param"
NAM["Parameters"][exchange_parameters_NAM_CQOF]["Group"] = "Parameters"
NAM["Parameters"][exchange_parameters_NAM_CQOF]["Key"] = "c_qof"
NAM["Parameters"][exchange_parameters_NAM_CQOF]["Unit"] = "[-]"
NAM["Parameters"][exchange_parameters_NAM_CQOF]["Range"] = (0.1, 1.0)
NAM["Parameters"][exchange_parameters_NAM_CKIF] = {}
NAM["Parameters"][exchange_parameters_NAM_CKIF]["Name"] = "C_kif"
NAM["Parameters"][exchange_parameters_NAM_CKIF]["File"] = "simul_SS.param"
NAM["Parameters"][exchange_parameters_NAM_CKIF]["Group"] = "Parameters"
NAM["Parameters"][exchange_parameters_NAM_CKIF]["Key"] = "c_kif"
NAM["Parameters"][exchange_parameters_NAM_CKIF]["Unit"] = "[h]"
NAM["Parameters"][exchange_parameters_NAM_CKIF]["Range"] = (200.0, 1_000.0)
NAM["Parameters"][exchange_parameters_NAM_LMAX] = {}
NAM["Parameters"][exchange_parameters_NAM_LMAX]["Name"] = "L_max"
NAM["Parameters"][exchange_parameters_NAM_LMAX]["File"] = "simul_RZ.param"
NAM["Parameters"][exchange_parameters_NAM_LMAX]["Group"] = "Parameters"
NAM["Parameters"][exchange_parameters_NAM_LMAX]["Key"] = "L_max"
NAM["Parameters"][exchange_parameters_NAM_LMAX]["Unit"] = "[mm]"
NAM["Parameters"][exchange_parameters_NAM_LMAX]["Range"] = (100.0, 300.0)
NAM["Parameters"][exchange_parameters_NAM_TG] = {}
NAM["Parameters"][exchange_parameters_NAM_TG]["Name"] = "TG"
NAM["Parameters"][exchange_parameters_NAM_TG]["File"] = "simul_RZ.param"
NAM["Parameters"][exchange_parameters_NAM_TG]["Group"] = "Parameters"
NAM["Parameters"][exchange_parameters_NAM_TG]["Key"] = "TG"
NAM["Parameters"][exchange_parameters_NAM_TG]["Unit"] = "[-]"
NAM["Parameters"][exchange_parameters_NAM_TG]["Range"] = (0.0 ,0.99)
NAM["Parameters"][exchange_parameters_NAM_CK12] = {}
NAM["Parameters"][exchange_parameters_NAM_CK12]["Name"] = "C_k 12"
NAM["Parameters"][exchange_parameters_NAM_CK12]["File"] = ["simul_OF.param", "simul_IF.param"]
NAM["Parameters"][exchange_parameters_NAM_CK12]["Group"] = ["Time Parameters", "NAM parameters"]
NAM["Parameters"][exchange_parameters_NAM_CK12]["Key"] = ["Lagtime", "Lagtime"]
NAM["Parameters"][exchange_parameters_NAM_CK12]["Unit"] = "[h]"
NAM["Parameters"][exchange_parameters_NAM_CK12]["Convertion Factor"] = [1/3600.0, 1.0]    # [sec] -> [h]
NAM["Parameters"][exchange_parameters_NAM_CK12]["Range"] = (10.0, 50.0)
NAM["Parameters"][exchange_parameters_NAM_CAREA] = {}
NAM["Parameters"][exchange_parameters_NAM_CAREA]["Name"] = "C_area"
NAM["Parameters"][exchange_parameters_NAM_CAREA]["File"] = "simul_RZ.param"
NAM["Parameters"][exchange_parameters_NAM_CAREA]["Group"] = "Parameters"
NAM["Parameters"][exchange_parameters_NAM_CAREA]["Key"] = "C_area"
NAM["Parameters"][exchange_parameters_NAM_CAREA]["Unit"] = "[-]"
NAM["Parameters"][exchange_parameters_NAM_CAREA]["Range"] = (0.5, 2.0)
NAM["Parameters"][exchange_parameters_NAM_CKBF] = {}
NAM["Parameters"][exchange_parameters_NAM_CKBF]["Name"] = "C_kbf"
NAM["Parameters"][exchange_parameters_NAM_CKBF]["File"] = "simul_BF.param"
NAM["Parameters"][exchange_parameters_NAM_CKBF]["Group"] = "Time Parameters"
NAM["Parameters"][exchange_parameters_NAM_CKBF]["Key"] = "Lagtime"
NAM["Parameters"][exchange_parameters_NAM_CKBF]["Unit"] = "[sec]"
NAM["Parameters"][exchange_parameters_NAM_CKBF]["Convertion Factor"] = 1/3600.0    # [sec] -> [h]
NAM["Parameters"][exchange_parameters_NAM_CKBF]["Range"] = (1_000.0,4_000.0)


# General model dictionnary 
modelParamsDict = {}
modelParamsDict[cst.tom_VHM] = VHM
modelParamsDict[cst.tom_GR4] = GR4
modelParamsDict[cst.tom_UH] = UH
modelParamsDict[cst.tom_2layers_linIF]= UHDIST_LINBF
modelParamsDict[cst.tom_HBV]= HBV
modelParamsDict[cst.tom_SAC_SMA]= SAC_SMA
modelParamsDict[cst.tom_NAM]= NAM

# %% Python-Fortran exchange constants

ptr_params = 1
ptr_opti_factors = 2
ptr_q_all = 3
ptr_time_delays = 4

fptr_update = 1
fptr_get_cvg = 2